from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfApplicationData(SpireObject):
    """
    Represents the pdf application data, used to store private data.
    """

    @property
    def Private(self) -> 'SpireObject':
        """
        The private data of application data dictionary.
        The valid type: string, Dictionary.
        """
        GetDllLibPdf().PdfApplicationData_get_Private.argtypes = [c_void_p]
        GetDllLibPdf().PdfApplicationData_get_Private.restype = c_void_p
        intPtr = GetDllLibPdf().PdfApplicationData_get_Private(self.Ptr)
        ret = None if intPtr == None else SpireObject(intPtr)
        return ret