from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfCheckBoxWidgetWidgetItemCollection(PdfStateWidgetItemCollection):
    """
    Represents a collection of checkbox group items.
    """

    def get_Item(self, index: int) -> 'PdfCheckBoxWidgetWidgetItem':
        """
        Gets the checkbox widget item at the specified index.
        """
        
        GetDllLibPdf().PdfCheckBoxWidgetWidgetItemCollection_get_Item.argtypes = [c_void_p, c_int]
        GetDllLibPdf().PdfCheckBoxWidgetWidgetItemCollection_get_Item.restype = c_void_p
        intPtr = GetDllLibPdf().PdfCheckBoxWidgetWidgetItemCollection_get_Item(self.Ptr, index)
        ret = None if intPtr == None else PdfCheckBoxWidgetWidgetItem(intPtr)
        return ret