from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfCode32Barcode(PdfCode39Barcode):
    @dispatch
    def __init__(self):
        """
        Initializes a new instance of the PdfCode32Barcode class.
        """
        GetDllLibPdf().PdfCode32Barcode_CreatePdfCode32Barcode.restype = c_void_p
        intPtr = GetDllLibPdf().PdfCode32Barcode_CreatePdfCode32Barcode()
        super(PdfCode32Barcode, self).__init__(intPtr)

    @dispatch
    def __init__(self, text: str):
        """
        Initializes a new instance of the PdfCode32Barcode class with the specified text.

        Args:
            text: The text to be encoded in the barcode.
        """
        GetDllLibPdf().PdfCode32Barcode_CreatePdfCode32BarcodeT.argtypes = [c_wchar_p]
        GetDllLibPdf().PdfCode32Barcode_CreatePdfCode32BarcodeT.restype = c_void_p
        intPtr = GetDllLibPdf().PdfCode32Barcode_CreatePdfCode32BarcodeT(text)
        super(PdfCode32Barcode, self).__init__(intPtr)
    """
    Represents a Code32 barcode.

    Only the following symbols are allowed in a Code 32 barcode: 1 2 3 4 5 6 7 8 9 0. The barcode length is 9 digits (8 user defined digits + 1 check digit).
    Code 32 barcodes are also known as Italian Pharmacode barcodes.
    """
   