from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfGotoNameAction(PdfAction):
    """
    Represents a PDF action that jumps to a named destination.
    """

    @property
    def Destination(self) -> str:
        """
        Gets or sets the destination.
        :return: The destination.
        """
        GetDllLibPdf().PdfGotoNameAction_get_Destination.argtypes = [c_void_p]
        GetDllLibPdf().PdfGotoNameAction_get_Destination.restype = c_void_p
        ret = PtrToStr(GetDllLibPdf().PdfGotoNameAction_get_Destination(self.Ptr))
        return ret

    @Destination.setter
    def Destination(self, value: str):
        """
        Sets the destination.
        :param value: The destination to set.
        """
        GetDllLibPdf().PdfGotoNameAction_set_Destination.argtypes = [c_void_p, c_wchar_p]
        GetDllLibPdf().PdfGotoNameAction_set_Destination(self.Ptr, value)