from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfShapeWidget(PdfLayoutWidget):
    """
    Base class for the main shapes.
    """

    def GetBounds(self) -> 'RectangleF':
        """
        Gets the bounds.

        Returns:
            rect: The bounds of the shape.
        """
        GetDllLibPdf().PdfShapeWidget_GetBounds.argtypes = [c_void_p]
        GetDllLibPdf().PdfShapeWidget_GetBounds.restype = c_void_p
        intPtr = GetDllLibPdf().PdfShapeWidget_GetBounds(self.Ptr)
        ret = None if intPtr == None else RectangleF(intPtr)
        return ret