from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfSignatureAppearanceField(PdfSignatureStyledField):
    """
    Represents form field with appearance custom support.
    """

    @property
    def Appearance(self) -> 'PdfAppearance':
        """
        Gets the appearance.

        Returns:
            The appearance.
        """
        GetDllLibPdf().PdfSignatureAppearanceField_get_Appearance.argtypes = [c_void_p]
        GetDllLibPdf().PdfSignatureAppearanceField_get_Appearance.restype = c_void_p
        intPtr = GetDllLibPdf().PdfSignatureAppearanceField_get_Appearance(self.Ptr)
        ret = None if intPtr == None else PdfAppearance(intPtr)
        return ret