from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class PdfStateWidgetItemCollection(PdfCollection):
    """
    Represents the collection of loaded state items.
    """

    def get_Item(self, index: int) -> 'PdfStateWidgetItem':
        """
        Gets the state item at the specified index.
        """
        
        GetDllLibPdf().PdfStateWidgetItemCollection_get_Item.argtypes = [c_void_p, c_int]
        GetDllLibPdf().PdfStateWidgetItemCollection_get_Item.restype = c_void_p
        intPtr = GetDllLibPdf().PdfStateWidgetItemCollection_get_Item(self.Ptr, index)
        ret = None if intPtr == None else PdfStateWidgetItem(intPtr)
        return ret