from enum import Enum
from plum import dispatch
from typing import TypeVar, Union, Generic, List, Tuple
from spire.pdf.common import *
from spire.pdf import *
from ctypes import *
import abc

class Utilities_PdfTable(SpireObject):
    """
    Define a PDF table.
    """

    def GetRowCount(self) -> int:
        """
        Get the current table row count.
        Returns:
            The row count.
        """
        GetDllLibPdf().Utilities_PdfTable_GetRowCount.argtypes = [c_void_p]
        GetDllLibPdf().Utilities_PdfTable_GetRowCount.restype = c_int
        ret = GetDllLibPdf().Utilities_PdfTable_GetRowCount(self.Ptr)
        return ret

    def GetColumnCount(self) -> int:
        """
        Get the current table column count.
        Returns:
            The column count.
        """
        GetDllLibPdf().Utilities_PdfTable_GetColumnCount.argtypes = [c_void_p]
        GetDllLibPdf().Utilities_PdfTable_GetColumnCount.restype = c_int
        ret = GetDllLibPdf().Utilities_PdfTable_GetColumnCount(self.Ptr)
        return ret

    def GetText(self, rowIndex: int, columnIndex: int) -> str:
        """
        Get value from the current table.
        Args:
            rowIndex: The row index, starting from 0.
            columnIndex: The column index, starting from 0.
        Returns:
            The text.
        """
        GetDllLibPdf().Utilities_PdfTable_GetText.argtypes = [c_void_p, c_int, c_int]
        GetDllLibPdf().Utilities_PdfTable_GetText.restype = c_void_p
        ret = PtrToStr(GetDllLibPdf().Utilities_PdfTable_GetText(self.Ptr, rowIndex, columnIndex))
        return ret